#ifndef		_DEBUG367_H
#define		_DEBUG367_H

#ifdef __cplusplus
extern "C" {
#endif

HINSTANCE mSaveInstance; /* ʵ */
HWND mSaveDialogMain; /* Ի */
HWND mSaveDialogI2c; /* I2CԻ */
HWND mSaveDialogSpi; /* SPIԻ */
HWND mSaveDialogHelp; /* HELPԻ */

CHAR mCaptionInform[] = "Ϣʾ";
UINT mIndex = 0; /* 豸 */
CHAR flag_open = 0; /* 豸ر־ */
mPCH367_IO_REG mBaseAddr; /* I/OռĴ */

char buffer_open[16];
char buffer_close[16];

WNDPROC WindowProcedureIoAddr, WindowProcedureIoData, WindowProcedureCfgAddr, WindowProcedureCfgData, \
		WindowProcedureI2cDevAddr, WindowProcedureI2cOffAddr, WindowProcedureI2cData, WindowProcedureI2cDid, \
		WindowProcedureI2cVid, WindowProcedureI2cRid, WindowProcedureI2cSdid, WindowProcedureI2cSvid;

typedef struct _VAR_TYPE {
	union {
		UCHAR cVar;
		UINT iVar;
		USHORT sVar;
		ULONG lVar;
	};
}mVAR_TYPE, *mpVAR_TYPE;

/* 볣,оƬ˵ */
#define WREN		0x06 /* дʹָ */
#define WRDI		0x04 /* дָֹ */
#define EWSR		0x50 /* д״̬Ĵʹָ */
#define RDSR		0x05 /* ״̬Ĵָ */
#define WRSR		0x01 /* д״̬Ĵָ,WELΪ0д */
#define READ		0x03 /* ָֽ */
#define FAST_READ	0x0B /* ָ */
#define BP			0x02 /* ֽдָ */
#define AAI			0xAF /* дָ */
#define SE			0x20 /* ָ */
#define BE			0xD8 /* ָ */
#define CE			0xC7 /* оƬָ*/
#define RMDI        0x90 /* /豸IDָ */

#define SPI_BUFFER_LENGTH 0x100 /* ÿζ256ֽ */
CHAR SpiFilePath[256] = ""; /* ļ· */

/* IRQ */
unsigned char cbyte = 0;
#define CH367_GPO_SET do{CH367mReadIoByte(mIndex, &mBaseAddr->mCH367IoPort[0xF1], &cbyte); CH367mWriteIoByte(mIndex, &mBaseAddr->mCH367IoPort[0xF1], cbyte |= 0x80);}while(0)
#define CH367_GPO_CLR do{CH367mReadIoByte(mIndex, &mBaseAddr->mCH367IoPort[0xF1], &cbyte); CH367mWriteIoByte(mIndex, &mBaseAddr->mCH367IoPort[0xF1], cbyte &= 0x7F);}while(0)
#define WM_INTNOTIFY (WM_USER + 1)
char irq_buf[100] = "";
ULONG mCount = 0;

LRESULT CALLBACK mDialogMain(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam); /* Ի¼ */
LRESULT CALLBACK mDialogI2c(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam); /* I2CԻ¼ */
LRESULT CALLBACK mDialogSpi(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam); /* SPIԻ¼ */
LRESULT CALLBACK mDialogHelp(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam); /* HELPԻ¼ */
void CALLBACK InterruptEvent(void); /* 豸ж֪ͨϢ */
void AddrRefresh(HWND hDialog); /* ȡַ */
void mSetI2C(HWND hDialog); /* I2Cд */
void mIOReadWrite(HWND hDialog); /* I/O˿ڶд */
void mConReadWrite(HWND hDialog); /* ÿռд */
void mInitCheckBox(HWND hDialog); /* ʼĬѡеѡ */
void mShowDllVer(HWND hDialog); /* ʾDLL汾 */
void mShowDevVer(HWND hDialog); /*ʾ汾 */

#ifdef __cplusplus
}
#endif

#endif // _DEBUG367_H