
/*============================= I/Oռ,ÿռ,I2Cش ==============================*/

LRESULT CALLBACK MyEditProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) /* Editص,ֻܽ'0'-'9','a'-'f','A'-'F','del' */
{
	WNDPROC OldProc = (WNDPROC)GetWindowLong(hWnd, GWL_USERDATA);
	if(Msg == WM_CHAR)
	{
		if(!( ( wParam >= '0' && wParam <= '9') || ( wParam >= 'a' && wParam <= 'f' ) || ( wParam >= 'A' && wParam <= 'F' ) || wParam == 0x08 ) )
		{
			return 0;
		} 
	}
	return CallWindowProc(OldProc, hWnd, Msg, wParam, lParam); 
}

UCHAR mCharToBcd(UCHAR iChar) /* ASCIIַתΪһλBCD,Чַ0-9,A-F,a-f,Чַ0FFH */
{
	UCHAR mBCD;
	if ( iChar >= '0' && iChar <= '9' ) mBCD = iChar - '0';
	else if ( iChar >= 'A' && iChar <= 'Z' ) mBCD = iChar - 'A' + 0x0a;
	else if ( iChar >= 'a' && iChar <= 'z' ) mBCD = iChar - 'a' + 0x0a;
	else mBCD = 0xff;
	return( mBCD );
}

mVAR_TYPE mCharToVar(UCHAR *sChar, UINT sLen, UINT sFlag) /* ַתֵ */
{
	UINT i;
	mVAR_TYPE mVarType;
	if(sLen != 0)
	{
		if(sLen > 1) /* ַȴ1 */
		{
			if(sFlag == 1) /* sFlagΪ1ʾULONG */
			{
				ULONG lReturn = 0;
				for(i = 0; i < sLen; i++)	
				{
					lReturn <<= 4;
					lReturn |= mCharToBcd(sChar[i]); 
				}
				mVarType.lVar = lReturn;
			}
			else if(sFlag == 0) /* sFlagΪ0ʾUSHORT */
			{
				USHORT sReturn = 0;
				for(i = 0; i < sLen; i++)
				{
					sReturn <<= 4;
					sReturn |= mCharToBcd(sChar[i]);
				}
				mVarType.sVar = sReturn;
			}
			else if(sFlag == 2) /* sFlagΪ2ʾUINT */
			{
				UINT iReturn = 0;
				for(i = 0; i < sLen; i++)
				{
					iReturn <<= 4;
					iReturn |= mCharToBcd(sChar[i]);
				}
				mVarType.iVar = iReturn;
			}
			else if(sFlag == 3)
			{
				UCHAR cReturn = 0;
				cReturn = (mCharToBcd(sChar[0]) << 4) | mCharToBcd(sChar[1]);
				mVarType.cVar = cReturn;
			}
		}
		else /* ַȵ1 */
		{
			mVarType.lVar = mCharToBcd(sChar[0]);
			mVarType.sVar = mCharToBcd(sChar[0]);
			mVarType.iVar = mCharToBcd(sChar[0]);
			mVarType.cVar = mCharToBcd(sChar[0]);
		}
	}
	else
	{
		mVarType.iVar = 0;
		mVarType.lVar = 0;
		mVarType.sVar = 0;
		mVarType.cVar = 0;
	}
	return mVarType;
}

BOOL mCheckWord(PVOID mWord, int dFlag) /* ַǷܴ洢ֻ˫ */
{
	if(dFlag == 4)
	{	
		if(((USHORT)mWord % 2)  == 0)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	else if(dFlag == 8)
	{
		if(((USHORT)mWord % 4)  == 0)
		{	
			return TRUE;
		}
		else
		{	
			return FALSE;
		}
	}
	return FALSE;
}

void mIOReadWrite(HWND hDialog) /* I/Oռд */
{
	mVAR_TYPE mVarType;
	UCHAR iAddr[8];
	UINT iAddrLen = 0;
	USHORT mAddr = 0;
	iAddrLen = GetDlgItemText(hDialog, IDC_EDTIOADDR, iAddr, 5);	
	mVarType = mCharToVar(iAddr, iAddrLen, 0); /* ȡֵַ */
	mAddr = mVarType.sVar;
	/*********I/O˿ֽڶд********/
	if(IsDlgButtonChecked(hDialog, IDC_RADIOBYTE) == BST_CHECKED)  
	{
		UCHAR oByte[8];
		UCHAR cByte;
		/* ֽ */
		if (IsDlgButtonChecked(hDialog, IDC_RADIOREAD) == BST_CHECKED)
		{
			if(iAddrLen)
			{
				if(IsDlgButtonChecked(hDialog, IDC_RADOFF) == BST_CHECKED) /* ƫƵַ */
				{	
					if(CH367mReadIoByte(mIndex, &mBaseAddr->mCH367IoPort[mAddr], &cByte)) /* I/O˿ڶ */
					{
						UCHAR sByte[8];
						sprintf(sByte, "%02X\x0", cByte);
						SetDlgItemText(hDialog, IDC_EDTIODATA, sByte);
					}
					else
					{
						MessageBox(hDialog, "ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
				else if(IsDlgButtonChecked(hDialog, IDC_RADIME) == BST_CHECKED)	/* ֱӵַ */
				{
					if(CH367mReadIoByte(mIndex, (PVOID)mAddr, &cByte))
					{
						UCHAR sByte[8];
						sprintf(sByte, "%02X\x0", cByte);
						SetDlgItemText(hDialog, IDC_EDTIODATA, sByte);
					}
					else
					{
						MessageBox(hDialog, "ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
			}
			else
			{
				MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
			}
		}
		/* дֽ */
		else if(IsDlgButtonChecked(hDialog, IDC_RADIOWRITE) == BST_CHECKED)
		{
			UINT oByteLen;
			mVAR_TYPE mVarByte;
			oByteLen = GetDlgItemText(hDialog, IDC_EDTIODATA, oByte, 5); /* ȡ */
			mVarByte = mCharToVar(oByte, oByteLen, 3); /* תΪӦֵ */
			cByte = mVarByte.cVar;
			if(iAddrLen && oByteLen) /* дַͿݲΪ */
			{
				if(IsDlgButtonChecked(hDialog, IDC_RADOFF) == BST_CHECKED) /* ƫƵַ */
				{
					if(CH367mWriteIoByte(mIndex, &mBaseAddr->mCH367IoPort[mAddr], cByte)) /* I/O˿д */
					{
						MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
					}
					else
					{
						MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
				else if(IsDlgButtonChecked(hDialog, IDC_RADIME) == BST_CHECKED)	/* ֱӵַ */
				{
					if(CH367mWriteIoByte(mIndex, (PVOID)mAddr, cByte)) /* I/O˿д */
					{
						MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
					}
					else
					{
						MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
			}
			else
			{
				MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
			}
		}
	}
	/************I/O˿ֲ****************/
	else if(IsDlgButtonChecked(hDialog, IDC_RADIOWORD) == BST_CHECKED)
	{
		UCHAR cWord[8]; /*  */
		USHORT num;
		USHORT oWord = 0;
		/* Ƿֵַͷ	*/
		if(!mCheckWord((PVOID)mAddr, 4))
		{
			MessageBox(hDialog, "ܴ洢ֵʼַ", "ʾ", MB_OK | MB_ICONSTOP);
			return;
		}
		if (IsDlgButtonChecked(hDialog,IDC_RADIOREAD) == BST_CHECKED) /* ѡж */
		{
			if(iAddrLen)
			{
				if(IsDlgButtonChecked(hDialog, IDC_RADOFF) == BST_CHECKED) /* ƫƵַ */
				{
					if(CH367mReadIoWord(mIndex, &mBaseAddr->mCH367IoPort[mAddr], &oWord)) /* I/O˿ڶһ */
					{
						UCHAR sByte[8];
						sprintf(sByte, "%02X%02X\x0", oWord & 0xFF, (oWord >> 8) & 0xFF);
						SetDlgItemText(hDialog,IDC_EDTIODATA,sByte); /*  */
					}
					else
					{
						MessageBox(hDialog, "ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
				else if(IsDlgButtonChecked(hDialog,IDC_RADIME) == BST_CHECKED) /* ֱӵַ */
				{
					if(CH367mReadIoWord(mIndex, (PVOID)mAddr, &oWord)) /* I/O˿ڶһ */
					{
						UCHAR sByte[8];
						sprintf(sByte, "%02X%02X\x0", oWord & 0xFF, (oWord>>8) & 0xFF);
						SetDlgItemText(hDialog,IDC_EDTIODATA,sByte); /*  */
					}
					else
					{
						MessageBox(hDialog,"ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
			}
			else
			{
				MessageBox(hDialog, "˿ڵַ!", "ʾ", MB_OK);
			}
		}
		else if(IsDlgButtonChecked(hDialog,IDC_RADIOWRITE) == BST_CHECKED) /* ѡд */
		{
			num = GetDlgItemText(hDialog, IDC_EDTIODATA, cWord, 5); /* ȡ */
			if(iAddrLen && num) /* ȡַ */
			{
				mVAR_TYPE mVarWord;
				mVarWord = mCharToVar(cWord, num, 0); /* תΪӦֵ */
				oWord = mVarWord.sVar;
				if(IsDlgButtonChecked(hDialog,IDC_RADOFF) == BST_CHECKED) /* ƫƵַ */
				{
					if(CH367mWriteIoWord(mIndex, &mBaseAddr->mCH367IoPort[mAddr], oWord)) /* I/O˿дһ */
					{
						MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
					}
					else
					{
						MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
				else if(IsDlgButtonChecked(hDialog,IDC_RADIME) == BST_CHECKED) /* ֱӵַ */
				{
					if(CH367mWriteIoWord(mIndex, (PVOID)mAddr, oWord)) /* I/O˿дһ */
					{
						MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
					}
					else
					{
						MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
			}
			else
			{
				MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
			}
		}
	}
	/**********I/O˿˫ֲ*************/
	else if(IsDlgButtonChecked(hDialog, IDC_RADIODWORD) == BST_CHECKED)
	{
		ULONG oDword = 0;
		UCHAR cDword[12]; /*  */
		ULONG num;
		/* Ƿ˫ֵַͷ */
		if(!mCheckWord((PVOID)mAddr, 8))
		{
			MessageBox(hDialog, "ܴ洢˫ֵʼַ!", "ʾ", MB_OK | MB_ICONSTOP);
			return;
		}
		/* ѡI/O˿ڶ */
		if (IsDlgButtonChecked(hDialog, IDC_RADIOREAD) == BST_CHECKED)	
		{
			if(iAddrLen)
			{
				if(IsDlgButtonChecked(hDialog, IDC_RADOFF) == BST_CHECKED) /* ƫƵַ */
				{
					/* I/O˿ڶȡһ˫ */
					if(CH367mReadIoDword(mIndex, &mBaseAddr->mCH367IoPort[mAddr], &oDword))
					{
						UCHAR sByte[12];
						sprintf(sByte, "%02X%02X%02X%02X\x0", oDword & 0xFF, (oDword >> 8) & 0xFF, (oDword >> 16) & 0xFF, (oDword >> 24) & 0xFF);
						SetDlgItemText( hDialog, IDC_EDTIODATA, sByte ); /* ֵ */
					}
					else
					{
						MessageBox(hDialog, "ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
				else if(IsDlgButtonChecked(hDialog, IDC_RADIME) == BST_CHECKED)	/* ֱӵַ */
				{
					/* I/O˿ڶȡһ˫ */
					if(CH367mReadIoDword(mIndex, (PVOID)mAddr, &oDword))
					{
						UCHAR sByte[12];
						sprintf(sByte, "%02X%02X%02X%02X\x0", oDword & 0xFF, (oDword>>8) & 0xFF, (oDword >> 16) & 0xFF, (oDword >> 24) & 0xFF);
						SetDlgItemText( hDialog, IDC_EDTIODATA, sByte ); /* ֵ */
					}
					else
					{
						MessageBox(hDialog,"ʧܣ","ʾ",MB_OK|MB_ICONSTOP);
					}
				}
			}
			else /* ȡַ */
			{
				MessageBox(hDialog, "˿ڵַ!", "ʾ", MB_OK);
			}
		}
		/* ѡI/O˿д */
		else if(IsDlgButtonChecked(hDialog, IDC_RADIOWRITE) == BST_CHECKED)
		{
			num = GetDlgItemText(hDialog, IDC_EDTIODATA, cDword, 9); /* ȡ */
			if(iAddrLen && num) /* ȡַ */
			{
				mVAR_TYPE mTypeDword;
				mTypeDword = mCharToVar(cDword, num, 1);
				oDword = mTypeDword.lVar;
				if(IsDlgButtonChecked(hDialog,IDC_RADOFF) == BST_CHECKED) /* ƫƵַ */
				{
					if(CH367mWriteIoDword(mIndex, &mBaseAddr->mCH367IoPort[mAddr], oDword))	/* I/O˿дһ˫ */
					{
						MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
					}
					else
					{
						MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
				else if(IsDlgButtonChecked(hDialog, IDC_RADIME) == BST_CHECKED)	/* ֱӵַ */
				{
					if(CH367mWriteIoDword(mIndex, (PVOID)mAddr, oDword)) /* I/O˿дһ˫ */
					{
						MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
					}
					else
					{
						MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
					}
				}
			}
			else
			{
				MessageBox(hDialog, "!", "ʾ" ,MB_OK);
			}
		}									
	}
	else
	{
		MessageBox(hDialog, "ѡдֽ,ֻ˫!", "ʾ", MB_OK);
	}
}

void AddrRefresh(HWND hDialog) /* ȡI/Oַ洢ַжϺ */
{
	ULONG oIntLine;
	/* ȡжϺ */
	if(CH367mGetIntLine(mIndex, &oIntLine)) 
	{
		UCHAR sByte[12];
		sprintf(sByte, "%02X\x0", oIntLine);
		SetDlgItemText(hDialog, IDC_EDTINTLINE, sByte);
	}
	else
	{
		MessageBox(hDialog, "жϺʧ!", "ʾ", MB_OK | MB_ICONSTOP);
		SetDlgItemText(hDialog, IDC_EDTINTLINE, "");
	}

	/* ȡI/Oַ */
	if(CH367mGetIoBaseAddr(mIndex, &mBaseAddr))
	{
		UCHAR sByte[12];
		sprintf(sByte, "%04X\x0", mBaseAddr);
		SetDlgItemText(hDialog, IDC_EDTBASEADDR, sByte);
	}
	else
	{
		MessageBox(hDialog, "I/Oַʧ!", "ʾ", MB_OK | MB_ICONSTOP);
		SetDlgItemText(hDialog, IDC_EDTBASEADDR, "");
	}
}

void mConReadWrite(HWND hDialog) /* ÿռд */
{
	UCHAR iAddr[8];
	USHORT mAddr;
	UCHAR oByte[8];
	UCHAR cByte;
	UINT iAddrLen;
	mVAR_TYPE mVarType;
	iAddrLen = GetDlgItemText(hDialog, IDC_EDTCONBYTEADDR, iAddr, 5); /* ȡַ */
	mVarType = mCharToVar(iAddr,iAddrLen,0);
	mAddr = mVarType.sVar;
	if(IsDlgButtonChecked(hDialog, IDC_RADCONBYTEREAD) == BST_CHECKED)	/* ѡдÿռһֽڵĲ */
	{
		if(iAddrLen) /* ȡַ */
		{
			if(CH367mReadConfig(mIndex, (PVOID)mAddr, &cByte)) /* ÿռһֽ */
			{
				UCHAR sByte[8];
				sprintf(sByte, "%02X\x0", cByte);
				SetDlgItemText(hDialog, IDC_EDTCONBYTEDATA, sByte);
			}
			else
			{
				MessageBox(hDialog, "ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
			}
		}
		else
		{
			MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
		}
	}
	else if(IsDlgButtonChecked(hDialog, IDC_RADCONBYTEWRITE) == BST_CHECKED) /* ѡÿռдֽڲ */
	{
		UINT oByteLen = 0;
		mVAR_TYPE mVarByte;
		oByteLen = GetDlgItemText(hDialog, IDC_EDTCONBYTEDATA, oByte, 3); /* ȡ */
		mVarByte = mCharToVar(oByte,oByteLen,3);
		cByte = mVarByte.cVar;
		if(iAddrLen && oByteLen)	
		{
			if(CH367mWriteConfig(mIndex, (PVOID)mAddr, cByte)) /* ÿռдһֽ */
			{	
				MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
			}
			else
			{
				MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
			}
		}
		else
		{
			MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
		}
	}
}

void mSetI2C(HWND hDialog) /* I2C */
{
	UCHAR dAddr[8];
	USHORT dAddrLen;
	UCHAR idAddr; /* ݵԪַ */
	UCHAR oByte[8];
	UCHAR cByte;
	mVAR_TYPE mVarTyped;
	dAddrLen = GetDlgItemText(hDialog, IDC_EDTDATADDR, dAddr, 3); /* ȡݵԪַ */
	mVarTyped = mCharToVar(dAddr, dAddrLen, 3);
	idAddr = mVarTyped.cVar;
	if (IsDlgButtonChecked(hDialog, IDC_RADI2CREAD) == BST_CHECKED)	/* ֽ */
	{
		if(dAddrLen) /* ȡݵԪַ */
		{
			if(CH367mReadI2C(mIndex, 0x50, idAddr, &cByte)) /* I2Cӿڶһֽ */
			{
				UCHAR sByte[8];
				sprintf(sByte, "%02X\x0", cByte);
				SetDlgItemText(hDialog, IDC_EDTI2CDATA, sByte);
			}
			else
			{
				MessageBox(hDialog, "ʧ!", "ʾ", MB_OK | MB_ICONSTOP);
			}
		}
		else
		{
			MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
		}
	}
	else if(IsDlgButtonChecked(hDialog, IDC_RADI2CWRITE) == BST_CHECKED) /* ѡI2Cд */
	{
		UINT oByteLen;
		UCHAR cByte;
		mVAR_TYPE mVarByte;
		oByteLen = GetDlgItemText(hDialog, IDC_EDTI2CDATA, oByte, 3); /* ȡд */
		mVarByte = mCharToVar(oByte, oByteLen, 0);
		cByte = mVarByte.cVar;
		if(dAddrLen && oByteLen)
		{
			if(CH367mWriteI2C(mIndex, 0x50, idAddr, cByte)) /* I2Cдһֽ */
			{
				MessageBox(hDialog, "дݳɹ!", "ʾ", MB_OK);
			}
			else
			{
				MessageBox(hDialog, "дʧ!", "ʾ", MB_OK | MB_ICONSTOP);
			}
		}
		else
		{
			MessageBox(hDialog, "ַ!", "ʾ", MB_OK);
		}
	}
}

void mInitCheckBox(HWND hDialog) /* ʼĬϵѡ */
{
	unsigned char i, tmp[4];
	CheckDlgButton(hDialog, IDC_RADOFF, BST_CHECKED); /* ƫƵַΪĬѡ */
	CheckDlgButton(hDialog, IDC_RADIOBYTE, BST_CHECKED); /* I/OֽڲΪĬѡ */
	CheckDlgButton(hDialog, IDC_RADIOREAD, BST_CHECKED); /* I/OΪĬѡ */
	CheckDlgButton(hDialog, IDC_RADCONBYTEREAD, BST_CHECKED); /* ÿռֽΪĬϲ */
	CheckDlgButton(hDialog, IDC_RADI2CREAD, BST_CHECKED); /* I2CΪĬϲ */
	CheckDlgButton(hDialog, IDC_SPI_31, BST_CHECKED); /* SPIʱƵ31.3MΪĬϲ */
	CheckDlgButton(hDialog, IDC_SPI3, BST_CHECKED); /* SPI3ΪĬϲ */	
	for(i = 0; i < 0x10; i++) /* ʼ豸,֧16豸 */
	{
		sprintf(tmp, "%d", i);
		SendDlgItemMessage(hDialog, IDC_DEVICE_NUMBER, CB_ADDSTRING, 0 , (LPARAM)tmp);
	}
	SendDlgItemMessage(hDialog, IDC_DEVICE_NUMBER, CB_SETCURSEL, 0, 0); /* õǰ豸Ϊ0 */	
	SendDlgItemMessage(hDialog, IDC_EDTIOADDR, EM_SETLIMITTEXT, 4, 0); /* EDITݳ */
	SendDlgItemMessage(hDialog, IDC_EDTIODATA, EM_SETLIMITTEXT, 8, 0);
	SendDlgItemMessage(hDialog, IDC_EDTDEVADDR, EM_SETLIMITTEXT, 2, 0);
	SendDlgItemMessage(hDialog, IDC_EDTDATADDR, EM_SETLIMITTEXT, 2, 0);
	SendDlgItemMessage(hDialog, IDC_EDTI2CDATA, EM_SETLIMITTEXT, 2, 0);
	SendDlgItemMessage(hDialog, IDC_EDTCONBYTEADDR, EM_SETLIMITTEXT, 2, 0);
	SendDlgItemMessage(hDialog, IDC_EDTCONBYTEDATA, EM_SETLIMITTEXT, 2, 0);
	WindowProcedureIoAddr = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTIOADDR), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTIOADDR), GWL_USERDATA, (LONG)WindowProcedureIoAddr);
	WindowProcedureIoData = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTIODATA), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTIODATA), GWL_USERDATA, (LONG)WindowProcedureIoData);
	WindowProcedureCfgAddr = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTCONBYTEADDR), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTCONBYTEADDR), GWL_USERDATA, (LONG)WindowProcedureCfgAddr);
	WindowProcedureCfgData = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTCONBYTEDATA), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTCONBYTEDATA), GWL_USERDATA, (LONG)WindowProcedureCfgData);
	WindowProcedureI2cDevAddr = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTDEVADDR), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTDEVADDR), GWL_USERDATA, (LONG)WindowProcedureI2cDevAddr);
	WindowProcedureI2cOffAddr = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTDATADDR), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTDATADDR), GWL_USERDATA, (LONG)WindowProcedureI2cOffAddr);
	WindowProcedureI2cData = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_EDTI2CDATA), GWL_WNDPROC, (LONG)MyEditProc);
	SetWindowLong(GetDlgItem(hDialog, IDC_EDTI2CDATA), GWL_USERDATA, (LONG)WindowProcedureI2cData);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_BTNIO), FALSE); /* ɼ */
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_BTNCONBYTE), FALSE);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_IRQ_TEST), FALSE);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_BTNI2C), FALSE);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_BTNI2C_PROGRAM), FALSE);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_SPI_SET), FALSE);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_SPI), FALSE);
	EnableWindow(GetDlgItem(mSaveDialogMain, IDC_CLOSE), FALSE);
}

void mShowDllVer(HWND hDialog) /* DLL汾 */
{
	ULONG ver = 0;
	char vers[8];
	ver = CH367GetVersion();  
	_ltoa(ver, vers, 16);
	if(!SetDlgItemText(hDialog, IDC_EDTDLLVER, vers))
	{	
		MessageBox(hDialog, "δܳɹDLL汾!", "ʾ", MB_ICONSTOP | MB_OK);
	}
}

void mShowDevVer(HWND hDialog) /* 汾 */
{
	ULONG ver = 0;
	char vers[8];
	ver = CH367GetDrvVersion();  
	_ltoa(ver, vers, 16);
	if(!SetDlgItemText(hDialog, IDC_EDTDEVVER, vers))
	{
		MessageBox(hDialog, "δܳɹ汾!", "ʾ", MB_ICONSTOP | MB_OK);
	}
}

/*============================= SPI 25VF512 ش ==============================*/

unsigned char write_enable(void) /* дʹ */
{
	unsigned char buffer[8];
	buffer[0] = WREN;
	if( CH367StreamSPI(mIndex, 0x01, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char write_disable(void) /* дֹ */
{
	unsigned char buffer[8];
	buffer[0] = WRDI;
	if( CH367StreamSPI(mIndex, 0x01, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char read_status_register(unsigned char *data) /* ״̬Ĵ */
{
	unsigned char buffer[8];
	unsigned long len = 0x01;
	buffer[0] = RDSR;
	if( CH367StreamSPI(mIndex, 0x01, buffer, &len, data) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char write_status_register_enable(void) /* д״̬Ĵʹ */
{
	unsigned char buffer[8];
	buffer[0] = EWSR;
	if( CH367StreamSPI(mIndex, 0x01, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char write_status_register(unsigned char status) /* д״̬Ĵ */
{
	unsigned char buffer[8];
	buffer[0] = WRSR;
	buffer[1] = status;
	if( CH367StreamSPI(mIndex, 0x02, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char check(void) /* WELλ */
{
	unsigned char data;
	int count = 10000;
	do{
		read_status_register(&data);
		if(count-- == 0) return FALSE;
	}while(data & 0x01);
	return TRUE;
}

unsigned char byte_program(unsigned long address, unsigned char data) /* ֽд */
{
	unsigned char buffer[8];
	buffer[0] = BP;
	buffer[1] = (unsigned char)(address >> 16 & 0xFF);
	buffer[2] = (unsigned char)(address >> 8 & 0xFF);
	buffer[3] = (unsigned char)(address & 0xFF);
	buffer[4] = data;
	if( CH367StreamSPI(mIndex, 0x05, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char sector_erase(unsigned long address) /*  */
{
	unsigned char buffer[8];
	buffer[0] = SE;
	buffer[1] = (unsigned char)(address >> 16 & 0xFF); 
	buffer[2] = (unsigned char)(address >> 8 & 0xFF);
	buffer[3] = (unsigned char)(address & 0xFF);
	if( CH367StreamSPI(mIndex, 0x04, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char bulk_erase(unsigned long address) /*  */
{
	unsigned char buffer[8];
	buffer[0] = BE;
	buffer[1] = (unsigned char)(address >> 16 & 0xFF);
	buffer[2] = (unsigned char)(address >> 8 & 0xFF);
	buffer[3] = (unsigned char)(address & 0xFF);
	if( CH367StreamSPI(mIndex, 0x04, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;	
}

unsigned char chip_erase(void) /* оƬ */
{
	unsigned char buffer[8];
	buffer[0] = CE;
	if( CH367StreamSPI(mIndex, 0x01, buffer, NULL, NULL) == FALSE ) return FALSE;
	return TRUE;		
}

unsigned char read_block(unsigned long address, unsigned long length, unsigned char *data) /* FLASH */
{
	unsigned char buffer[8];
	if(length > 4096) return FALSE;
	buffer[0] = READ;
	buffer[1] = (unsigned char)(address >> 16 & 0xFF);
	buffer[2] = (unsigned char)(address >> 8 & 0xFF);
	buffer[3] = (unsigned char)(address & 0xFF);
	if( CH367StreamSPI(mIndex, 0x04, buffer, &length, data) == FALSE ) return FALSE;
	return TRUE;	
}

unsigned char read_block_fast(unsigned long address, unsigned long length, unsigned char *data) /* ٶFLASH */
{
	unsigned char buffer[8];
	if(length > 4096) return FALSE;
	buffer[0] = FAST_READ;
	buffer[1] = (unsigned char)(address >> 16 & 0xFF);
	buffer[2] = (unsigned char)(address >> 8 & 0xFF);
	buffer[3] = (unsigned char)(address & 0xFF);
	buffer[4] = 0x00;
	if( CH367StreamSPI(mIndex, 0x05, buffer, &length, data) == FALSE ) return FALSE;
	return TRUE;
}

unsigned char read_manufacturer_device_id(unsigned char *data) /* /豸ID */
{
	unsigned char buffer[8];
	unsigned long len = 0x04;
	buffer[0] = RMDI;
	buffer[1] = 0x00;
	buffer[2] = 0x00;
	buffer[3] = 0x00;
	if( CH367StreamSPI(mIndex, 0x04, buffer, &len, data) == FALSE ) return FALSE;
	return TRUE;	
}

void load_file(void) /* ѡ񽫷͵ļ */
{
	TCHAR szFile[260] = "\0";
	OPENFILENAME openfilename;
	TCHAR szFilter[] = __TEXT( "Images(*.TXT)\0*.TXT; \0All Files(*.*)\0*.*\0\0" );
	openfilename.lStructSize       = sizeof ( OPENFILENAME );
	openfilename.hwndOwner         = mSaveDialogSpi;
	openfilename.hInstance         = mSaveInstance;
	openfilename.lpstrFilter       = szFilter;
	openfilename.lpstrCustomFilter = NULL;
	openfilename.nMaxCustFilter    = 0;
	openfilename.nFilterIndex      = 0;
	openfilename.lpstrFile         = szFile;
	openfilename.nMaxFile          = sizeof(szFile);
	openfilename.lpstrFileTitle    = NULL;
	openfilename.nMaxFileTitle     = 0;
	openfilename.lpstrInitialDir   = NULL;
	openfilename.lpstrTitle		   = "ѡصĿļ";
	openfilename.nFileOffset       = 0;
	openfilename.nFileExtension    = 0;
	openfilename.lpstrDefExt       = NULL;
	openfilename.lCustData         = 0;
	openfilename.lpfnHook 		   = NULL;
	openfilename.lpTemplateName    = NULL;
	openfilename.Flags             = OFN_SHOWHELP | OFN_EXPLORER | OFN_READONLY | OFN_FILEMUSTEXIST;
	if (GetOpenFileName(&openfilename) ) /* ȡļ·浽ָĻ */
	{
		memset(SpiFilePath, 0x00, sizeof(SpiFilePath));
		memcpy(SpiFilePath, openfilename.lpstrFile, strlen(openfilename.lpstrFile));
		SetDlgItemText(mSaveDialogSpi, IDC_FILE, SpiFilePath);  /* ʾļ· */
	}
}

void read_flash(void) /* FLASHдļ */
{
	OPENFILENAME openfilename;  
	CHAR szFile[260] = "\0";
	HANDLE hFile;
	char DirName[256];
	unsigned long address, mTotal = 0;
	unsigned char *p, buffer[1024 * 64];
	DWORD Num;
	p = buffer;
	GetCurrentDirectory(sizeof(DirName), DirName); /* ȡǰ· */
	openfilename.lStructSize       = sizeof(OPENFILENAME);
	openfilename.hwndOwner         = NULL;
	openfilename.hInstance         = NULL;
	openfilename.lpstrFilter       = __TEXT("Images(*.TXT)\0*.TXT; *.DIB\0All Files(*.*)\0*.*\0\0");
	openfilename.lpstrCustomFilter = NULL;
	openfilename.nMaxCustFilter    = 0;
	openfilename.nFilterIndex      = 0;
	openfilename.lpstrFile         = szFile;
	openfilename.nMaxFile          = sizeof(szFile);
	openfilename.lpstrFileTitle    = NULL;
	openfilename.nMaxFileTitle     = 0;
	openfilename.lpstrInitialDir   = DirName;
	openfilename.lpstrTitle        = "ļ";
	openfilename.nFileOffset       = 0;
	openfilename.nFileExtension    = 0;
	openfilename.lpstrDefExt       = NULL;
	openfilename.lCustData         = 0;
	openfilename.lpfnHook 		   = NULL;
	openfilename.lpTemplateName    = NULL;
	openfilename.Flags             = OFN_SHOWHELP | OFN_EXPLORER | OFN_READONLY | OFN_FILEMUSTEXIST;
	
	if (GetSaveFileName(&openfilename)) /* ֵָļ */
	{  
		hFile = CreateFile ( szFile,  
			GENERIC_WRITE | GENERIC_READ,  
			FILE_SHARE_READ | FILE_SHARE_WRITE,  
			NULL,  
			CREATE_ALWAYS,  
			FILE_ATTRIBUTE_NORMAL,  
			NULL);  
		if (hFile != INVALID_HANDLE_VALUE) /* ֵָļɹ */
		{  
			for(address = 0; address < 0x10000; address += SPI_BUFFER_LENGTH)
			{
				/* FLASH ÿζ256ֽ */
				if(CH364mReadFlash(0,address,p, SPI_BUFFER_LENGTH))
				{
					mTotal = mTotal + SPI_BUFFER_LENGTH;
					p += SPI_BUFFER_LENGTH;
				}
				else
				{
					MessageBox(mSaveDialogSpi, "FLASHʧ", mCaptionInform, MB_ICONSTOP | MB_OK);
					CloseHandle(hFile);
					return;
				}
			}
			if ( ! WriteFile(hFile, buffer, mTotal, &Num, NULL) ) /* ѽջедļ,ʱ,رմļ */
			{ 
				MessageBox(mSaveDialogSpi, "дļʧ", mCaptionInform, MB_ICONSTOP | MB_OK);
				CloseHandle(hFile);
				return;
			}
			MessageBox(mSaveDialogSpi, "FLASHɹ", mCaptionInform, MB_OK);
			CloseHandle(hFile);
		}
		else /* ʱ, رմļ  */
		{  
			CloseHandle(hFile);
			return;
		}
	}
}

void write_flash(void) /* Ѵ򿪵ļдFLASH */
{
	CHAR pFileN[100] = "";
	ULONG i, address;
	HANDLE hFile;
	DWORD mFileSize = 0;
	UCHAR *mBuffer;

	for(i = 0; i < 100; i++)
	{
		pFileN[i] = '\0';
	}
	if(!GetDlgItemText(mSaveDialogSpi, IDC_FILE, pFileN, 100)) /* ȡѡļ· */
	{  
		if (SpiFilePath == "")
		{  
			GetDlgItemText(mSaveDialogSpi, IDC_FILE, pFileN, 100);
		}
		else
		{  
			strcpy(pFileN, "");
			memcpy(pFileN, SpiFilePath, strlen(SpiFilePath)); /* ļ·pFileN */
			pFileN[strlen(SpiFilePath)] = '\0';
		}
	}
	if(pFileN[0] == '\0') /* ûѡļ,ʾ */
	{  
		MessageBox(mSaveDialogSpi, "ļ", mCaptionInform, MB_ICONSTOP);
	}
	else 
	{  
		if ( ( hFile = CreateFile (  /* ѡļȡļ */
			( LPCTSTR ) pFileN,
			GENERIC_READ,
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			( HANDLE ) NULL ) ) == ( HANDLE ) -1 )
		{ 
			MessageBox(mSaveDialogSpi, "/ļ", mCaptionInform, MB_ICONSTOP);
			return;
		}
		mFileSize = GetFileSize (hFile, NULL); /* ȡļĴС */
		if(mFileSize > 1024 * 64)
		{
			MessageBox(mSaveDialogSpi, "ֻܴС64Kļ", mCaptionInform, MB_ICONSTOP);
			CloseHandle(hFile); 
			return;
		}
		if(mFileSize == 0xFFFFFFFF)
		{  
			MessageBox(mSaveDialogSpi, "ȡļĴС", mCaptionInform, MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
		mBuffer = (UCHAR *)malloc(mFileSize); /* ļĻ */
		if(mBuffer == NULL)
		{ 
			MessageBox(mSaveDialogSpi, "仺", mCaptionInform, MB_ICONSTOP);
			CloseHandle(hFile);
			free(mBuffer);
			return;
		}
		memset(mBuffer, '\0', mFileSize); /* ջ */
		if (!(ReadFile(hFile, mBuffer, mFileSize, &i, NULL))) /* ȡļݵĻ,ʱ,رļ,ͷŻ */
		{  
			MessageBox(mSaveDialogSpi, "ļ", mCaptionInform, MB_ICONSTOP);
			CloseHandle(hFile);
			free(mBuffer);
			return;
		}
		CloseHandle(hFile);
		/*
		write_enable(); // дʹ  
		write_status_register_enable();
		write_status_register(0x00);
		write_disable(); // дֹ 

		for(address = 0; address < mFileSize; address++)
		{
			write_enable(); // дʹ 
			byte_program(address, *mBuffer); // ֽд 
			write_disable(); // дֹ 
			if(check()) // WELλ 
			{
				mBuffer++;
			}
			else
			{
				MessageBox(mSaveDialogSpi, "дFLASHʧ,FLASHѾ,û", mCaptionInform, MB_OK); // flashѾ 
				return;
			}
		}
		*/
		CH364mWriteFlash(0,0,mBuffer,mFileSize);
		MessageBox(mSaveDialogSpi, "дFLASH", mCaptionInform, MB_OK);
	}
}

void erase_flash(void) /* FLASH */
{
	/*
	write_enable(); // дʹ 
	if(chip_erase())
	{
		MessageBox(mSaveDialogSpi, "FLASHɹ", mCaptionInform, MB_OK);
	}
	else
	{
		MessageBox(mSaveDialogSpi, "FLASHʧ", mCaptionInform, MB_ICONSTOP | MB_OK);
	}
	write_disable(); // дֹ 
	*/
	CH364mLockFlash(0,0);
	if( CH364mEarseFlash(0,0,64*1024))
	{
		MessageBox(mSaveDialogSpi, "FLASHɹ", mCaptionInform, MB_OK);
	}
	else
	{
		MessageBox(mSaveDialogSpi, "FLASHʧ", mCaptionInform, MB_ICONSTOP | MB_OK);
	}
}

LRESULT CALLBACK mDialogSpi(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam) /* SPIԻ¼ */
{
	switch(uMessage)
	{
	case WM_INITDIALOG:
		{
			mSaveDialogSpi = hDialog;
			EnableWindow(GetDlgItem(mSaveDialogMain, IDC_SPI), FALSE);
		}
		return TRUE;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDC_FLASH_LOADFILE: /* ļ */
				{
					load_file();
				}
				return TRUE;
			case IDC_FLASH_READ: /* FLASH */
				{
					read_flash();
				}
				return TRUE;
			case IDC_FLASH_WRITE: /* дFLASH */
				{
					write_flash();
				}
				return TRUE;
			case IDC_FLASH_ERASE: /* FLASH */
				{
					erase_flash();
				}
				return TRUE;
			case IDC_FLASH_EXIT:
			case WM_DESTROY: /* ˳ */
				EnableWindow(GetDlgItem(mSaveDialogMain, IDC_SPI), TRUE);
				EndDialog(hDialog, 1);	
				return TRUE;
			}
		}
		break;
	}
	return FALSE;  
}

/*============================= I2Cش==============================*/

void eeprom_write(void) /* ޸VID,DID... */
{
	mVAR_TYPE mVarType;
	UCHAR i, data[8], buffer[32];
	UINT Len = 0;
	USHORT Value = 0;
	buffer[0] = 0x78;
	buffer[1] = 0x00;
	buffer[2] = 0x00;
	buffer[3] = 0x00;
	Len = GetDlgItemText(mSaveDialogI2c, IDC_VID, data, 5);
	mVarType = mCharToVar(data, Len, 0); /* ȡVID */
	Value = mVarType.sVar;
	buffer[4] = Value & 0xFF;
	buffer[5] = Value >> 8;
	Len = GetDlgItemText(mSaveDialogI2c, IDC_DID, data, 5);
	mVarType = mCharToVar(data, Len, 0); /* ȡVID */
	Value = mVarType.sVar;
	buffer[6] = Value & 0xFF;
	buffer[7] = Value >> 8;
	Len = GetDlgItemText(mSaveDialogI2c, IDC_RID, data, 3);	
	mVarType = mCharToVar(data, Len, 3); /* ȡRID */
	buffer[8] = mVarType.cVar;
	buffer[9] = 0x00;
	buffer[10] = 0x00;
	buffer[11] = 0x10;
	Len = GetDlgItemText(mSaveDialogI2c, IDC_SVID, data, 5);
	mVarType = mCharToVar(data, Len, 0); /* ȡSVID */
	Value = mVarType.sVar;
	buffer[12] = Value & 0xFF;
	buffer[13] = Value >> 8;
	Len = GetDlgItemText(mSaveDialogI2c, IDC_SID, data, 5);
	mVarType = mCharToVar(data, Len, 0); /* ȡSVID */
	Value = mVarType.sVar;
	buffer[14] = Value & 0xFF;
	buffer[15] = Value >> 8;
	for(i = 0x10; i < 0x20; i++)
	{
		buffer[i] = 0x00;
	}
	for(i = 0; i < 0x20; i++)
	{
		if(CH367mWriteI2C(mIndex, 0x50, i, buffer[i]))
		{
			Sleep(20); /* Ҫʱ */
		}
		else
		{
			MessageBox(mSaveDialogI2c, "дEEPROMʧ,EEPROM𻵻û", mCaptionInform, MB_OK);
			return;
		}
	}
	MessageBox(mSaveDialogI2c, "дEEPROM", mCaptionInform, MB_OK);
}

void eeprom_read(void) /* EEPROM */
{
	UCHAR i, sByte[8], data[32];
	for(i = 0; i < 0x20; i++)
	{
		if(CH367mReadI2C(mIndex, 0x50, i, &data[i]))
		{
			
		}
		else
		{
			MessageBox(mSaveDialogI2c, "дEEPROMʧ,EEPROM𻵻û", mCaptionInform, MB_OK);
			return;
		}
	}
	sprintf(sByte, "%02X%02X\x0", data[5], data[4]);
	SetDlgItemText(mSaveDialogI2c, IDC_VID, sByte); /* VID */
	sprintf(sByte, "%02X%02X\x0", data[7], data[6]);
	SetDlgItemText(mSaveDialogI2c, IDC_DID, sByte); /* DID */
	sprintf(sByte, "%02X\x0", data[8]);
	SetDlgItemText(mSaveDialogI2c, IDC_RID, sByte); /* RID */
	sprintf(sByte, "%02X%02X\x0", data[13], data[12]);
	SetDlgItemText(mSaveDialogI2c, IDC_SVID, sByte); /* SVID */
	sprintf(sByte, "%02X%02X\x0", data[15], data[14]);
	SetDlgItemText(mSaveDialogI2c, IDC_SID, sByte); /* SID */
}

LRESULT CALLBACK mDialogI2c(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam) /* I2CԻ¼ */
{
	switch(uMessage)
	{
	case WM_INITDIALOG: /* ʼ */
		{
			mSaveDialogI2c = hDialog;
			EnableWindow(GetDlgItem(mSaveDialogMain, IDC_BTNI2C_PROGRAM), FALSE);
			SendDlgItemMessage(hDialog, IDC_VID, EM_SETLIMITTEXT, 4, 0);
			SendDlgItemMessage(hDialog, IDC_DID, EM_SETLIMITTEXT, 4, 0);
			SendDlgItemMessage(hDialog, IDC_RID, EM_SETLIMITTEXT, 2, 0);
			SendDlgItemMessage(hDialog, IDC_SVID, EM_SETLIMITTEXT, 4, 0);
			SendDlgItemMessage(hDialog, IDC_SID, EM_SETLIMITTEXT, 4, 0);
			WindowProcedureI2cDid = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_DID), GWL_WNDPROC, (LONG)MyEditProc);
			SetWindowLong(GetDlgItem(hDialog, IDC_DID), GWL_USERDATA, (LONG)WindowProcedureI2cDid);
			WindowProcedureI2cVid = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_VID), GWL_WNDPROC, (LONG)MyEditProc);
			SetWindowLong(GetDlgItem(hDialog, IDC_VID), GWL_USERDATA, (LONG)WindowProcedureI2cVid);
			WindowProcedureI2cRid = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_RID), GWL_WNDPROC, (LONG)MyEditProc);
			SetWindowLong(GetDlgItem(hDialog, IDC_RID), GWL_USERDATA, (LONG)WindowProcedureI2cRid);
			WindowProcedureI2cSdid = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_SID), GWL_WNDPROC, (LONG)MyEditProc);
			SetWindowLong(GetDlgItem(hDialog, IDC_SID), GWL_USERDATA, (LONG)WindowProcedureI2cSdid);
			WindowProcedureI2cSvid = (WNDPROC)SetWindowLong(GetDlgItem(hDialog, IDC_SVID), GWL_WNDPROC, (LONG)MyEditProc);
			SetWindowLong(GetDlgItem(hDialog, IDC_SVID), GWL_USERDATA, (LONG)WindowProcedureI2cSvid);
			eeprom_read(); /* eeprom */
		}
		return TRUE;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDC_PROGRAM: /* дEEPROM */
				{
					eeprom_write();
				}
				return TRUE;
			case IDC_PROGRAM_EXIT:
			case WM_DESTROY: /* ˳ */
				EnableWindow(GetDlgItem(mSaveDialogMain, IDC_BTNI2C_PROGRAM), TRUE);
				EndDialog(hDialog, 1);
				return TRUE;
			}
		}
		break;
	}
	return FALSE;  
}

/*============================= жش ==============================*/

void CALLBACK InterruptEvent(void) /* 豸ж֪ͨϢ */
{		
	mCount++; /* жϴ */
	CH367_GPO_SET;
	PostMessage(mSaveDialogMain, WM_INTNOTIFY, 0, 0); /* 豸жϢ */
}

/*============================= HELPش ==============================*/

LPCTSTR help_buf = "1-ֶ֧豸 \r\n\
  ͨ豸ѡĸ豸 \r\n\
  0Ϊһ豸(CPU豸) \r\n\
  1Ϊڶ豸 \r\n\
  ... \r\n\
  nΪn-1豸 \r\n\
2-I/Oд \r\n\
  ֽ֧//˫ģʽI/O˿ڷ,ĬΪֽڷʽ \r\n\
  ֱ֧ӵַ/ƫƵַI/O˿ \r\n\
      ֱӵַԷ豸I/Oռ \r\n\
      ƫƵַֻܷCH367I/Oռ \r\n\
  ֶ֧/д \r\n\
3-ÿռд \r\n\
  ֽ֧ڶ/д,ϸ˵CH367оƬֲ \r\n\
4-EEPROMд \r\n\
  CH367֧I2CӿͨѶ,CH367ʾ24C02,ֶ֧/дEEPROM \r\n\
5-SPIӿFLASH \r\n\
  CH367֧SPIӿͨѶ,CH367ʾ25VF512,ֶ֧//FLASH \r\n\
6-жϲ \r\n\
  ƽ/жͿѡ(ڴ豸ʱ) \r\n\
  óͨGP0INT#ж,ڲʱINT#A15̽ \r\n\
  óʹõ͵ƽЧĵƽʽ,ʽڴ豸ʱ \r\n\
  óͨ\"ж\"GP0һ½źźһźŴӶж";

void help(void) /* ʾhelp */
{
	SetWindowText(GetDlgItem(mSaveDialogHelp, IDC_EDIT_HELP), help_buf);
}

LRESULT CALLBACK mDialogHelp(HWND hDialog, UINT uMessage, WPARAM wParam, LPARAM lParam) /* HELPԻ¼ */
{
	switch(uMessage)
	{
	case WM_INITDIALOG: /* ʼ */
		{
			mSaveDialogHelp = hDialog;
			EnableWindow(GetDlgItem(mSaveDialogMain, IDC_DESCRIPTION), FALSE);
			help();
			SetFocus(NULL);
		}
		return FALSE;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case WM_DESTROY: /* ˳ */
				EnableWindow(GetDlgItem(mSaveDialogMain, IDC_DESCRIPTION), TRUE);
				EndDialog(hDialog, 1);
				return TRUE;
			}
		}
		break;
	}
	return FALSE;  
}
